/********************************************************* begin of preamble
**
** Copyright (C) 2003-2012 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
package com.sos.JSHelper.DataElements;

/**
* \class JSDataElementDateISO 
* 
* \brief JSDataElementDateISO - 
* 
* \details
* Mapics liefert in den CSV-Schnittstellendateien bereits ISO-Datumsangaben. 
* Eine Datumskonvertierung nach XML ist nicht mehr notwendig.
*
* \section JSDataElementDateISO.java_intro_sec Introduction
*
* \section JSDataElementDateISO.java_samples Some Samples
*
* \code
*   .... code goes here ...
* \endcode
*
* <p style="text-align:center">
* <br />---------------------------------------------------------------------------
* <br /> APL/Software GmbH - Berlin
* <br />##### generated by ClaviusXPress (http://www.sos-berlin.com) #########
* <br />---------------------------------------------------------------------------
* </p>
* \author EQALS
* @version $Id: JSDataElementDateISO.java 14731 2011-07-05 20:50:42Z sos $31.07.2009
* \see reference
*
* Created on 31.07.2009 12:28:28
 */

public class JSDataElementDateISO extends JSDataElement {

	@SuppressWarnings("unused")
	private final String	conClassName	= "JSDataElementDateISO";

	public JSDataElementDateISO() {
		//
	}

	public JSDataElementDateISO(String pstrValue) {
		super(pstrValue);
	}

	public JSDataElementDateISO(String pstrValue, String pstrDescription) {
		super(pstrValue, pstrDescription);
	}

	public JSDataElementDateISO(String pstrValue, String pstrDescription, int pintSize, int pintPos, String pstrFormatString, String pstrColumnHeader,
			String pstrXMLTagName) {
		super(pstrValue, pstrDescription, pintSize, pintPos, pstrFormatString, pstrColumnHeader, pstrXMLTagName);
	}
	
	/**
	 *
	 * \brief doInit
	 *
	 * \details
	 *
	 * \return void
	 *
	 */
	@Override
	public void doInit () {
//		super.Size(10);
		super.Description("DateISO");
		super.ColumnHeader("DateISO");
		super.XMLTagName("DateISO");
//		super.setFormatPattern(JSDateFormat.dfDATE_SHORT);
		super.OmitXMLTag(true);

	}
}
