/********************************************************* begin of preamble
**
** Copyright (C) 2003-2012 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
package com.sos.jobnet.classes;
import java.util.ArrayList;
import java.util.List;

import org.apache.log4j.Logger;

import com.sos.jobnet.interfaces.IJobNetCollection;
import com.sos.jobnet.interfaces.IPlanItem;

/**
* \class JobNetNodesCollection 
* 
* \brief JobNetNodesCollection - 
* 
* \details
*
* \section JobNetNodesCollection.java_intro_sec Introduction
*
* \section JobNetNodesCollection.java_samples Some Samples
*
* \code
*   .... code goes here ...
* \endcode
*
* <p style="text-align:center">
* <br />---------------------------------------------------------------------------
* <br /> APL/Software GmbH - Berlin
* <br />##### generated by ClaviusXPress (http://www.sos-berlin.com) #########
* <br />---------------------------------------------------------------------------
* </p>
* \author oh
* @version $Id: JobNetCollection.java 19341 2013-03-05 09:06:04Z ss $
* \see reference
*
* Created on 24.02.2012 12:40:58
 */
/**
 * @author oh
 *
 */
public class JobNetCollection implements IJobNetCollection {

	private final String	conClassName	= "JobNetNodesCollection";
	public final String		conSVNVersion	= "$Id: JobNetCollection.java 19341 2013-03-05 09:06:04Z ss $";

	@SuppressWarnings("unused")
	private static final Logger		logger			= Logger.getLogger(JobNetCollection.class);
	private List<IPlanItem>	items		= new ArrayList<IPlanItem>();

	public JobNetCollection() {
		//
	}

	protected List<IPlanItem> getItems() {
		return items;
	}


	public String getItemsAsText() {
		StringBuffer result = new StringBuffer();
		Status status = new Status();
		for(IPlanItem item : items) {
			if(result.length() > 0)
				result.append(", ");
			result.append(String.format("%s(%s)", item.getJobnetNodeItem().getNode(), status.getMsg(item.getStatusNode())));
		}
		return result.toString();
	}
	
	/**
	 * \brief add
	 * 
	 * \details
	 *
	 * @param item
	 */
	@Override
	public void add(IPlanItem item) {
		@SuppressWarnings("unused")
		final String conMethodName = conClassName + "::add";
		getItems().add(item);
	} // public void add
	
	@Override
	public int size() {
		return items.size();
	}

	@Override
	public IPlanItem get(int i) {
		return getItems().get(i);
	}

}
