/********************************************************* begin of preamble
**
** Copyright (C) 2003-2012 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
package com.sos.jobnet.classes;

public enum JobNetOrderParams {
	successor(false),
	predecessor(false),
	script_to_execute(false),
	scripttoexecute(false),
	event_on_success(false),
	eventonsuccess(false),
	event_on_error(false),
	eventonerror(false),
	wait_for_events(false),
	waitforevents(false),
	ondemand(false),
	on_demand(false),
	jobnet_id_parameter_name(true),
	jobnetidparametername(false),
	CalculationRule(false),
	ResultParameterName(false),
	LoadId(false),
	LoadIdDateFormat(false),
	LoadIdDurationType(false);
	
	private final boolean isPublic;
	
	private JobNetOrderParams(boolean isPublic) {
		this.isPublic = isPublic;
	}

	public static boolean isPublicParameter(String name) {
		boolean result = false;
		try {
			JobNetOrderParams p = JobNetOrderParams.valueOf(name);
			result = p.isPublic;
		} catch(Exception e) {
			result = true;		// unknown parameters are public anyway
		}
		return result;
	}
}
