/********************************************************* begin of preamble
**
** Copyright (C) 2003-2012 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
package com.sos.jobnet.interfaces;

import com.sos.jobnet.classes.EventsCollection;

/**
* \class IWaitHandler 
* 
* \brief IWaitHandler - 
* 
* \details
*
* \section IWaitHandler.java_intro_sec Introduction
*
* \section IWaitHandler.java_samples Some Samples
*
* \code
*   .... code goes here ...
* \endcode
*
* <p style="text-align:center">
* <br />---------------------------------------------------------------------------
* <br /> APL/Software GmbH - Berlin
* <br />##### generated by ClaviusXPress (http://www.sos-berlin.com) #########
* <br />---------------------------------------------------------------------------
* </p>
* \author oh
* @version $Id: IWaitHandler.java 19375 2013-03-09 17:53:38Z ss $
* \see reference
*
* Created on 24.02.2012 14:20:29
 */
public interface IWaitHandler {
	
	public abstract void setNodeStatusListener(IJobNetPlanEventListener listener);
	public abstract boolean isBootstrap();
	public abstract void setWaiterStatusToRunning();
	public abstract void setNodeStatusToRunning();
	public abstract boolean isNodeNotProcessed();
	public abstract boolean isNodeStarted();
	public abstract boolean isWaiterSkipped();
	public abstract boolean isRunnerSkipped();
	public abstract boolean isRunnerOnDemand();
	public abstract boolean isRunnerRunning();
	public abstract void setNodeStatusToWaiting();
	public abstract void setRunnerStatusToRunning();
	public abstract void setWaiterStatusToFinish();
	public abstract void setWaiterStatusToError();
	public abstract void setNodeStatusToError();
	public abstract void setStartTime();
	public abstract boolean isReadyForProcessing();

	public abstract IJobNetCollection getWaitingNodes();
	public abstract EventsCollection getMissingEvents();
	
	public abstract void open();
	public abstract void close();
}
