/********************************************************* begin of preamble
**
** Copyright (C) 2003-2012 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
package com.sos.scheduler.model.commands;

import org.apache.log4j.Logger;

import com.sos.scheduler.model.SchedulerObjectFactory;
import com.sos.scheduler.model.objects.JSObjJob;

/**
* \class JSCmdAddJobs 
* 
* \brief JSCmdAddJobs - 
* 
* \details
*
* This junit-test will add two jobs to the current job scheduler instance.
* First job ist a Java-API job and the second is a java-script driven job.
* 
* There is no checking in job scheduler wether the jobs exists.
* If the job already exist it will be overwritten without any further notice.
* 
* \return void
*
* \snippet junit\com\sos\scheduler\model\SchedulerObjectFactoryTest.java testCreateAddJobs
*
* <p style="text-align:center">
* <br />---------------------------------------------------------------------------
* <br /> APL/Software GmbH - Berlin
* <br />##### generated by ClaviusXPress (http://www.sos-berlin.com) #########
* <br />---------------------------------------------------------------------------
* </p>
* \author oh
* @version $Id$    03.02.2011
* \see reference
*
* Created on 03.02.2011 14:20:18
 */

/**
 * @author oh
 *
 */
public class JSCmdAddJobs extends AddJobs {

	@SuppressWarnings("unused")
	private final String		conClassName	= "JSCmdAddJobs";
	@SuppressWarnings("unused")
	private static final Logger	logger			= Logger.getLogger(JSCmdAddJobs.class);


	public JSCmdAddJobs(SchedulerObjectFactory schedulerObjectFactory) {
		super();
		objFactory = schedulerObjectFactory;
	}
	
	public void add(JSObjJob pobjJob) {
	
	@SuppressWarnings("unused")
	final String	conMethodName	= conClassName + "::add";
	
	this.getJob().add(pobjJob);
	
} // private void add

}
