/********************************************************* begin of preamble
**
** Copyright (C) 2003-2012 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
#include "spooler.h"

#include "../kram/sos_java.h"
#include "../zschimmer/java.h"

using namespace std;
using namespace zschimmer::javabridge;

namespace sos {
namespace scheduler {

//------------------------------------------------Java_module_script_instance::Java_module_instance

Java_module_script_instance::Java_module_script_instance( Module* module )
: 
    Java_module_instance(module)
{
}
//----------------------------------------------------------------Java_module_script_instance::init

void Java_module_script_instance::init()
{
    Env         env;
    Local_frame local_frame ( 10 );
    Java_idispatch_stack_frame stack_frame;

    Module_instance::init();

    _java_class = env.find_class( java_adapter_job() );
    jmethodID method_id = java_method_id( "<init>(Ljava/lang/String;Ljava/lang/String;)V" );   // Konstruktor
    if( !method_id )  env.throw_java( "GetMethodID", java_adapter_job() );

    jstring language = env.jstring_from_string(_module->_language);
    jstring code = env.jstring_from_string(_module->read_source_script());

    assert( _jobject == NULL );
    _jobject = env->NewObject( _java_class, method_id, language, code );
    if( !_jobject || env->ExceptionCheck() )  env.throw_java( java_adapter_job() + " Konstruktor" );

}

//-------------------------------------------------------------------------------------------------

} //namespace scheduler
} //namespace sos
